/**************************************************************************/
/*  editor_file_system_directory.hpp                                      */
/**************************************************************************/
/*                         This file is part of:                          */
/*                             GODOT ENGINE                               */
/*                        https://godotengine.org                         */
/**************************************************************************/
/* Copyright (c) 2014-present Godot Engine contributors (see AUTHORS.md). */
/* Copyright (c) 2007-2014 Juan Linietsky, Ariel Manzur.                  */
/*                                                                        */
/* Permission is hereby granted, free of charge, to any person obtaining  */
/* a copy of this software and associated documentation files (the        */
/* "Software"), to deal in the Software without restriction, including    */
/* without limitation the rights to use, copy, modify, merge, publish,    */
/* distribute, sublicense, and/or sell copies of the Software, and to     */
/* permit persons to whom the Software is furnished to do so, subject to  */
/* the following conditions:                                              */
/*                                                                        */
/* The above copyright notice and this permission notice shall be         */
/* included in all copies or substantial portions of the Software.        */
/*                                                                        */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,        */
/* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF     */
/* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. */
/* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY   */
/* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   */
/* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE      */
/* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                 */
/**************************************************************************/

// THIS FILE IS GENERATED. EDITS WILL BE LOST.

#ifndef GODOT_CPP_EDITOR_FILE_SYSTEM_DIRECTORY_HPP
#define GODOT_CPP_EDITOR_FILE_SYSTEM_DIRECTORY_HPP

#include <godot_cpp/core/object.hpp>
#include <godot_cpp/variant/string.hpp>
#include <godot_cpp/variant/string_name.hpp>

#include <godot_cpp/core/class_db.hpp>

#include <type_traits>

namespace godot {

class EditorFileSystemDirectory : public Object {
	GDEXTENSION_CLASS(EditorFileSystemDirectory, Object)

public:
	int32_t get_subdir_count() const;
	EditorFileSystemDirectory *get_subdir(int32_t p_idx);
	int32_t get_file_count() const;
	String get_file(int32_t p_idx) const;
	String get_file_path(int32_t p_idx) const;
	StringName get_file_type(int32_t p_idx) const;
	String get_file_script_class_name(int32_t p_idx) const;
	String get_file_script_class_extends(int32_t p_idx) const;
	bool get_file_import_is_valid(int32_t p_idx) const;
	String get_name();
	String get_path() const;
	EditorFileSystemDirectory *get_parent();
	int32_t find_file_index(const String &p_name) const;
	int32_t find_dir_index(const String &p_name) const;

protected:
	template <typename T, typename B>
	static void register_virtuals() {
		Object::register_virtuals<T, B>();
	}

public:
};

} // namespace godot

#endif // ! GODOT_CPP_EDITOR_FILE_SYSTEM_DIRECTORY_HPP
