/**************************************************************************/
/*  editor_resource_picker.hpp                                            */
/**************************************************************************/
/*                         This file is part of:                          */
/*                             GODOT ENGINE                               */
/*                        https://godotengine.org                         */
/**************************************************************************/
/* Copyright (c) 2014-present Godot Engine contributors (see AUTHORS.md). */
/* Copyright (c) 2007-2014 Juan Linietsky, Ariel Manzur.                  */
/*                                                                        */
/* Permission is hereby granted, free of charge, to any person obtaining  */
/* a copy of this software and associated documentation files (the        */
/* "Software"), to deal in the Software without restriction, including    */
/* without limitation the rights to use, copy, modify, merge, publish,    */
/* distribute, sublicense, and/or sell copies of the Software, and to     */
/* permit persons to whom the Software is furnished to do so, subject to  */
/* the following conditions:                                              */
/*                                                                        */
/* The above copyright notice and this permission notice shall be         */
/* included in all copies or substantial portions of the Software.        */
/*                                                                        */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,        */
/* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF     */
/* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. */
/* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY   */
/* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   */
/* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE      */
/* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                 */
/**************************************************************************/

// THIS FILE IS GENERATED. EDITS WILL BE LOST.

#ifndef GODOT_CPP_EDITOR_RESOURCE_PICKER_HPP
#define GODOT_CPP_EDITOR_RESOURCE_PICKER_HPP

#include <godot_cpp/classes/h_box_container.hpp>
#include <godot_cpp/classes/ref.hpp>
#include <godot_cpp/variant/packed_string_array.hpp>
#include <godot_cpp/variant/string.hpp>

#include <godot_cpp/core/class_db.hpp>

#include <type_traits>

namespace godot {

class Object;
class Resource;

class EditorResourcePicker : public HBoxContainer {
	GDEXTENSION_CLASS(EditorResourcePicker, HBoxContainer)

public:
	void set_base_type(const String &p_base_type);
	String get_base_type() const;
	PackedStringArray get_allowed_types() const;
	void set_edited_resource(const Ref<Resource> &p_resource);
	Ref<Resource> get_edited_resource();
	void set_toggle_mode(bool p_enable);
	bool is_toggle_mode() const;
	void set_toggle_pressed(bool p_pressed);
	void set_editable(bool p_enable);
	bool is_editable() const;
	virtual void _set_create_options(Object *p_menu_node);
	virtual bool _handle_menu_selected(int32_t p_id);

protected:
	template <typename T, typename B>
	static void register_virtuals() {
		HBoxContainer::register_virtuals<T, B>();
		if constexpr (!std::is_same_v<decltype(&B::_set_create_options), decltype(&T::_set_create_options)>) {
			BIND_VIRTUAL_METHOD(T, _set_create_options, 3975164845);
		}
		if constexpr (!std::is_same_v<decltype(&B::_handle_menu_selected), decltype(&T::_handle_menu_selected)>) {
			BIND_VIRTUAL_METHOD(T, _handle_menu_selected, 3067735520);
		}
	}

public:
};

} // namespace godot

#endif // ! GODOT_CPP_EDITOR_RESOURCE_PICKER_HPP
