/**************************************************************************/
/*  editor_resource_tooltip_plugin.hpp                                    */
/**************************************************************************/
/*                         This file is part of:                          */
/*                             GODOT ENGINE                               */
/*                        https://godotengine.org                         */
/**************************************************************************/
/* Copyright (c) 2014-present Godot Engine contributors (see AUTHORS.md). */
/* Copyright (c) 2007-2014 Juan Linietsky, Ariel Manzur.                  */
/*                                                                        */
/* Permission is hereby granted, free of charge, to any person obtaining  */
/* a copy of this software and associated documentation files (the        */
/* "Software"), to deal in the Software without restriction, including    */
/* without limitation the rights to use, copy, modify, merge, publish,    */
/* distribute, sublicense, and/or sell copies of the Software, and to     */
/* permit persons to whom the Software is furnished to do so, subject to  */
/* the following conditions:                                              */
/*                                                                        */
/* The above copyright notice and this permission notice shall be         */
/* included in all copies or substantial portions of the Software.        */
/*                                                                        */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,        */
/* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF     */
/* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. */
/* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY   */
/* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   */
/* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE      */
/* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                 */
/**************************************************************************/

// THIS FILE IS GENERATED. EDITS WILL BE LOST.

#ifndef GODOT_CPP_EDITOR_RESOURCE_TOOLTIP_PLUGIN_HPP
#define GODOT_CPP_EDITOR_RESOURCE_TOOLTIP_PLUGIN_HPP

#include <godot_cpp/classes/ref.hpp>
#include <godot_cpp/classes/ref_counted.hpp>

#include <godot_cpp/core/class_db.hpp>

#include <type_traits>

namespace godot {

class Control;
class Dictionary;
class String;
class TextureRect;

class EditorResourceTooltipPlugin : public RefCounted {
	GDEXTENSION_CLASS(EditorResourceTooltipPlugin, RefCounted)

public:
	void request_thumbnail(const String &p_path, TextureRect *p_control) const;
	virtual bool _handles(const String &p_type) const;
	virtual Control *_make_tooltip_for_path(const String &p_path, const Dictionary &p_metadata, Control *p_base) const;

protected:
	template <typename T, typename B>
	static void register_virtuals() {
		RefCounted::register_virtuals<T, B>();
		if constexpr (!std::is_same_v<decltype(&B::_handles), decltype(&T::_handles)>) {
			BIND_VIRTUAL_METHOD(T, _handles, 3927539163);
		}
		if constexpr (!std::is_same_v<decltype(&B::_make_tooltip_for_path), decltype(&T::_make_tooltip_for_path)>) {
			BIND_VIRTUAL_METHOD(T, _make_tooltip_for_path, 4100114520);
		}
	}

public:
};

} // namespace godot

#endif // ! GODOT_CPP_EDITOR_RESOURCE_TOOLTIP_PLUGIN_HPP
